Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.io
Class WrapperBufferOutput

`java.lang.Object
com.tangosol.util.Base
com.tangosol.io.WrapperBufferOutput`

All Implemented Interfaces:
  OutputStreaming, WriteBuffer.BufferOutput, java.io.DataOutput

      public class WrapperBufferOutput

extends Base
implements WriteBuffer.BufferOutput

This is an imitation BufferOutput implementation that provides the BufferOutput interface by delegating to an object that implements the DataOutput interface. Primarily, this is intended as a base class for building specific-purpose DataOutput wrappers.

Author:
  jh 2007.11.17

Field Summary

Fields inherited from interface com.tangosol.io.WriteBuffer.BufferOutput
`MAX_PACKED_INT_SIZE, MAX_PACKED_LONG_SIZE`

Constructor Summary
`WrapperBufferOutput(java.io.DataOutput out)` Construct a WrapperBufferOutput that will write to the specified object implementing the DataOutput interface.
`WrapperBufferOutput(java.io.DataOutput out, WriteBuffer wb)` Construct a WrapperBufferOutput that will write to the specified object implementing the DataOutput interface and return the optional WriteBuffer as its underlying destination.

Method Summary
`void` | `close()` Closes this OutputStream and releases any associated system resources.
`void` | `flush()` Flushes this OutputStream and forces any buffered output bytes to be written.
`WriteBuffer` | `getBuffer()` Get the WriteBuffer object that this BufferOutput is writing to.
`java.io.DataOutput` | `getDataOutput()` Obtain the underlying object providing the DataOutput interface that this object is delegating to.
`int` | `getOffset()` Determine the current offset of this BufferOutput within the underlying WriteBuffer.
`void` | `setOffset(int of)` Specify the offset of the next byte to write to the underlying WriteBuffer.
`void` | `write(byte[] ab)` Writes all the bytes in the array `ab`.
`void` | `write(byte[] ab, int of, int cb)` Writes `cb` bytes starting at offset `of` from the array `ab`.
`void` | `write(int b)` Writes the eight low-order bits of the argument `b`.
`void` | `writeBoolean(boolean f)` Writes the boolean value `f`.
`void` | `writeBuffer(ReadBuffer buf)` Write all the bytes from the passed ReadBuffer object.
`void` | `writeBuffer(ReadBuffer buf, int of, int cb)` Write `cb` bytes from the passed ReadBuffer object starting at offset `of` within the passed ReadBuffer.
`void` | `writeByte(int b)` Writes the eight low-order bits of the argument `b`.
`void` | `writeBytes(java.lang.String s)` Writes the String `s`, but only the low-order byte from each character of the String is written.
`void` | `writeChar(int n)` Writes a char value, comprised of the 16 low-order bits of the argument `ch`; the 16 high-order bits of `ch` are ignored.
`void` | `writeChars(java.lang.String s)` Writes the String `s` as a sequence of characters.
`void` | `writeDouble(double dfl)` Writes a double value.
`void` | `writeFloat(float fl)` Writes a float value.
`void` | `writeInt(int n)` Writes an int value.
`void` | `writeLong(long l)` Writes a long value.
`void` | `writePackedInt(int n)` Write an int value using a variable-length storage-format.
`void` | `writePackedLong(long l)` Write a long value using a variable-length storage-format.
`void` | `writeSafeUTF(java.lang.String s)` Write a variable-length encoded UTF packed String.
`void` | `writeShort(int n)` Writes a short value, comprised of the 16 low-order bits of the argument `n`; the 16 high-order bits of `n` are ignored.
`void` | `writeStream(InputStreaming stream)` Write the remaining contents of the specified InputStreaming object.
`void` | `writeStream(InputStreaming stream, int cb)` Write the specified number of bytes of the specified InputStreaming object.
`void` | `writeUTF(java.lang.String s)` Writes the String `s` as a sequence of characters, but using UTF-8 encoding for the characters, and including the String length data so that the corresponding `DataInput.readUTF()` method can reconstitute a String from the written data.

Constructor Detail

### WrapperBufferOutput

    public WrapperBufferOutput(java.io.DataOutput out)

  Construct a WrapperBufferOutput that will write to the specified object implementing the DataOutput interface.
  Parameters:
    `out` - an object implementing DataOutput to write to

### WrapperBufferOutput

    public WrapperBufferOutput(java.io.DataOutput out,
                               WriteBuffer wb)

  Construct a WrapperBufferOutput that will write to the specified object implementing the DataOutput interface and return the optional WriteBuffer as its underlying destination.
  Parameters:
    `out` - an object implementing DataOutput to write to
    `wb` - an optional object implementing WriteBuffer

Method Detail

### write

    public void write(int b)
               throws java.io.IOException

  Writes the eight low-order bits of the argument `b`. The 24 high-order bits of `b` are ignored.
  Specified by:
    `write` in interface `OutputStreaming`
  Specified by:
    `write` in interface `java.io.DataOutput`
  Parameters:
    `b` - the byte to write (passed as an integer)
  Throws:
    `java.io.IOException` - if an I/O error occurs

### write

    public void write(byte[] ab)
               throws java.io.IOException

  Writes all the bytes in the array `ab`.
  Specified by:
    `write` in interface `OutputStreaming`
  Specified by:
    `write` in interface `java.io.DataOutput`
  Parameters:
    `ab` - the byte array to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### write

    public void write(byte[] ab,
                      int of,
                      int cb)
               throws java.io.IOException

  Writes `cb` bytes starting at offset `of` from the array `ab`.
  Specified by:
    `write` in interface `OutputStreaming`
  Specified by:
    `write` in interface `java.io.DataOutput`
  Parameters:
    `ab` - the byte array to write from
    `of` - the offset into `ab` to start writing from
    `cb` - the number of bytes from `ab` to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### flush

    public void flush()
               throws java.io.IOException

  Flushes this OutputStream and forces any buffered output bytes to be written.
  Specified by:
    `flush` in interface `OutputStreaming`
  Throws:
    `java.io.IOException` - if an I/O error occurs

### close

    public void close()
               throws java.io.IOException

  Closes this OutputStream and releases any associated system resources.
  Specified by:
    `close` in interface `OutputStreaming`
  Specified by:
    `close` in interface `WriteBuffer.BufferOutput`
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeBoolean

    public void writeBoolean(boolean f)
                      throws java.io.IOException

  Writes the boolean value `f`.
  Specified by:
    `writeBoolean` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeBoolean` in interface `java.io.DataOutput`
  Parameters:
    `f` - the boolean to be written
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeByte

    public void writeByte(int b)
                   throws java.io.IOException

  Writes the eight low-order bits of the argument `b`. The 24 high-order bits of `b` are ignored.
  Specified by:
    `writeByte` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeByte` in interface `java.io.DataOutput`
  Parameters:
    `b` - the byte to write (passed as an integer)
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeShort

    public void writeShort(int n)
                    throws java.io.IOException

  Writes a short value, comprised of the 16 low-order bits of the argument `n`; the 16 high-order bits of `n` are ignored.
  Specified by:
    `writeShort` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeShort` in interface `java.io.DataOutput`
  Parameters:
    `n` - the short to write (passed as an integer)
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeChar

    public void writeChar(int n)
                   throws java.io.IOException

  Writes a char value, comprised of the 16 low-order bits of the argument `ch`; the 16 high-order bits of `ch` are ignored.
  Specified by:
    `writeChar` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeChar` in interface `java.io.DataOutput`
  Parameters:
    `n` - the char to write (passed as an integer)
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeInt

    public void writeInt(int n)
                  throws java.io.IOException

  Writes an int value.
  Specified by:
    `writeInt` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeInt` in interface `java.io.DataOutput`
  Parameters:
    `n` - the int to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeLong

    public void writeLong(long l)
                   throws java.io.IOException

  Writes a long value.
  Specified by:
    `writeLong` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeLong` in interface `java.io.DataOutput`
  Parameters:
    `l` - the long to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeFloat

    public void writeFloat(float fl)
                    throws java.io.IOException

  Writes a float value.
  Specified by:
    `writeFloat` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeFloat` in interface `java.io.DataOutput`
  Parameters:
    `fl` - the float to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeDouble

    public void writeDouble(double dfl)
                     throws java.io.IOException

  Writes a double value.
  Specified by:
    `writeDouble` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeDouble` in interface `java.io.DataOutput`
  Parameters:
    `dfl` - the double to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeBytes

    public void writeBytes(java.lang.String s)
                    throws java.io.IOException

  Writes the String `s`, but only the low-order byte from each character of the String is written.
  Specified by:
    `writeBytes` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeBytes` in interface `java.io.DataOutput`
  Parameters:
    `s` - the String to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeChars

    public void writeChars(java.lang.String s)
                    throws java.io.IOException

  Writes the String `s` as a sequence of characters.
  Specified by:
    `writeChars` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeChars` in interface `java.io.DataOutput`
  Parameters:
    `s` - the String to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeUTF

    public void writeUTF(java.lang.String s)
                  throws java.io.IOException

  Writes the String `s` as a sequence of characters, but using UTF-8 encoding for the characters, and including the String length data so that the corresponding `DataInput.readUTF()` method can reconstitute a String from the written data.
  Specified by:
    `writeUTF` in interface `WriteBuffer.BufferOutput`
  Specified by:
    `writeUTF` in interface `java.io.DataOutput`
  Parameters:
    `s` - the String to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### getBuffer

    public WriteBuffer getBuffer()

  Get the WriteBuffer object that this BufferOutput is writing to.
  Specified by:
    `getBuffer` in interface `WriteBuffer.BufferOutput`
  Returns:
    the underlying WriteBuffer object

### writeSafeUTF

    public void writeSafeUTF(java.lang.String s)
                      throws java.io.IOException

  Write a variable-length encoded UTF packed String. The major differences between this implementation and DataOutput is that this implementation supports null values and is not limited to 64KB UTF-encoded values.

  The binary format for a Safe UTF value is a "packed int" for the binary length followed by the UTF-encoded byte stream. The length is either -1 (indicating a null String) or in the range `0 .. Integer.MAX_VALUE` (inclusive). The UTF-encoded portion uses a format identical to DataOutput.

  Specified by:
    `writeSafeUTF` in interface `WriteBuffer.BufferOutput`
  Parameters:
    `s` - a String value to write; may be null
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writePackedInt

    public void writePackedInt(int n)
                        throws java.io.IOException

  Write an int value using a variable-length storage-format.

  The format differs from DataOutput in that DataOutput always uses a fixed-length 4-byte Big Endian binary format for int values. The "packed" format includes a sign bit (0x40) and a continuation bit (0x80) in the first byte, followed by the least 6 significant bits of the int value. Subsequent bytes (each appearing only if the previous byte had its continuation bit set) include a continuation bit (0x80) and the next least 7 significant bits of the int value. In this way, a 32-bit value is encoded into 1-5 bytes, depending on the magnitude of the int value being encoded.

  Specified by:
    `writePackedInt` in interface `WriteBuffer.BufferOutput`
  Parameters:
    `n` - an int value to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writePackedLong

    public void writePackedLong(long l)
                         throws java.io.IOException

  Write a long value using a variable-length storage-format.

  The format differs from DataOutput in that DataOutput always uses a fixed-length 8-byte Big Endian binary format for long values. The "packed" format includes a sign bit (0x40) and a continuation bit (0x80) in the first byte, followed by the least 6 significant bits of the long value. Subsequent bytes (each appearing only if the previous byte had its continuation bit set) include a continuation bit (0x80) and the next least 7 significant bits of the long value. In this way, a 64-bit value is encoded into 1-10 bytes, depending on the magnitude of the long value being encoded.

  Specified by:
    `writePackedLong` in interface `WriteBuffer.BufferOutput`
  Parameters:
    `l` - a long value to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeBuffer

    public void writeBuffer(ReadBuffer buf)
                     throws java.io.IOException

  Write all the bytes from the passed ReadBuffer object.

  This is functionally equivalent to the following code:

       getBuffer().write(getOffset(), buf);

  Specified by:
    `writeBuffer` in interface `WriteBuffer.BufferOutput`
  Parameters:
    `buf` - a ReadBuffer object
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeBuffer

    public void writeBuffer(ReadBuffer buf,
                            int of,
                            int cb)
                     throws java.io.IOException

  Write `cb` bytes from the passed ReadBuffer object starting at offset `of` within the passed ReadBuffer.

  This is functionally equivalent to the following code:

       getBuffer().write(getOffset(), buf, of, cb);

  Specified by:
    `writeBuffer` in interface `WriteBuffer.BufferOutput`
  Parameters:
    `buf` - a ReadBuffer object
    `of` - the offset within the ReadBuffer of the first byte to write to this BufferOutput
    `cb` - the number of bytes to write
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeStream

    public void writeStream(InputStreaming stream)
                     throws java.io.IOException

  Write the remaining contents of the specified InputStreaming object.

  This is functionally equivalent to the following code:

       getBuffer().write(getOffset(), stream);

  Specified by:
    `writeStream` in interface `WriteBuffer.BufferOutput`
  Parameters:
    `stream` - the stream of bytes to write to this BufferOutput
  Throws:
    `java.io.IOException` - if an I/O error occurs, specifically if an IOException occurs reading from the passed stream

### writeStream

    public void writeStream(InputStreaming stream,
                            int cb)
                     throws java.io.IOException

  Write the specified number of bytes of the specified InputStreaming object.

  This is functionally equivalent to the following code:

       getBuffer().write(getOffset(), stream, cb);

  Specified by:
    `writeStream` in interface `WriteBuffer.BufferOutput`
  Parameters:
    `stream` - the stream of bytes to write to this BufferOutput
    `cb` - the exact number of bytes to read from the stream and write to this BufferOutput
  Throws:
    `java.io.EOFException` - if the stream is exhausted before the number of bytes indicated could be read
    `java.io.IOException` - if an I/O error occurs, specifically if an IOException occurs reading from the passed stream

### getOffset

    public int getOffset()

  Determine the current offset of this BufferOutput within the underlying WriteBuffer.
  Specified by:
    `getOffset` in interface `WriteBuffer.BufferOutput`
  Returns:
    the offset of the next byte to write to the WriteBuffer

### setOffset

    public void setOffset(int of)

  Specify the offset of the next byte to write to the underlying WriteBuffer.
  Specified by:
    `setOffset` in interface `WriteBuffer.BufferOutput`
  Parameters:
    `of` - the offset of the next byte to write to the WriteBuffer

### getDataOutput

    public java.io.DataOutput getDataOutput()

  Obtain the underlying object providing the DataOutput interface that this object is delegating to.
  Returns:
    the underlying DataOutput

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.